#ifndef d2h_HH
#define d2h_HH

#define PUBLIC
#define PRIVATE static

/***********************************************************************
     "d2h.hh": lotos Data language to C Header.
***********************************************************************/

/***********************************
  (C) Copyright 1992-1993; dit/upm
   Distributed under the conditions stated in the
   TOPO General Public License (see file LICENSE)
 ***********************************
 $Log: d2h.desc,v $
 * Revision 2.6  1995/01/17  09:55:07  lotos
 * dynamic table sizing
 *
 * Revision 2.5  1993/06/10  14:04:00  lotos
 * new annotation CALL
 *
 * Revision 2.4  1993/05/28  10:51:50  lotos
 * opcion -c tiene niveles
 *
 * Revision 2.3  1993/01/18  18:16:12  lotos
 * distribution issues
 *
 * Revision 2.2  1992/11/17  18:35:08  lotos
 * separate internal (kdatum) and external (udatum)
 * new annotation ldc at the very and of the spec
 * new annotation ldcinit at the beginning
 *
 * Revision 2.1  1992/10/14  18:16:00  lotos
 * new philosophy to write ADTs,
 * every new expression is supposed to be pointed once,
 * in order to share a value, it has to be kd_copy'ed
 * functions assume their arguments are absolutely theirs
 *
 * Revision 1.4  1992/09/02  14:04:23  lotos
 * avoid casting on LHS (for portability)
 *
 * Revision 1.3  92/02/29  13:26:54  lotos
 * flags for pretty printing: optional
 * 
 * Revision 1.2  92/01/15  12:45:01  lotos
 * ready to distribute
 * 
 * Revision 1.1  91/10/02  16:59:37  lotos
 * Initial revision
 * 
 ***********************************/

#include "dtok.hh"
#include "clng.hh"


typedef struct
{ int put_help;
  int add_cmt;
  int indt_incr;
} tPROG_FLAG;	/* program flag storage structure */

/* program name */
#ifndef d2h_IMP
extern	char *prog_name;
#else
	char *prog_name= NULL;
#endif

/* program flag storage */
#ifndef d2h_IMP
extern	tPROG_FLAG prog_flag;
#else
	tPROG_FLAG prog_flag= { FALSE, 0, 0 };
#endif

#endif
